
(function ($, Drupal) {
  Drupal.behaviors.custom_jsoneditor = {
    attach: function (context) {
      $('.jsoneditor--wrapper').each(function () {
        if(context != document && context.nodeName != 'FORM') {
          return;
        }

        var options = {
          mode: 'tree',
          modes: ['code', 'tree', 'view', 'form', 'text'],
          ace: ace,
          container: this,
          onChangeText: function (jsonString) {
            var input = getInputFromContainer(this.container);
            if (input) {
              input.val(jsonString);
            }

            // Call api
            $.post('/admin/demo/api', {json_data: jsonString}, function (response) {
              // Document viwer.
              $('#document-view-content').html(response.view);

              // Json Response
              var editorDiv = $('div.jsoneditor--wrapper[data-input="ws_response"]:first');
              if (editorDiv.length > 0) {
                editorDiv[0].editor.set(response.result);
              }
            });
          }
        };

        if (!this.editor) {
          this.editor = new JSONEditor(this, options);
        }
        var input = getInputFromContainer(this);

        if (input) {
          var inputValue = input.val();

          if (inputValue) {
            var json = JSON.parse(inputValue);
            this.editor.set(json);
          } else {
            this.editor.set([]);
          }
        }
      });

      // Sidebar settings
      $('.s-openbtn').on('click', function() {
        document.getElementById("sidebar-settings").style.left = "-32px";
        document.getElementById("main").style.marginLeft = "25%";

        this.style.display = "none";
        document.getElementById("e-openbtn").style.display = "block";

        // Close edit panel
        document.getElementById("sidebar-editing").style.left = "-40%";
        document.getElementById("s-openbtn").style.top = "211px";

      });
      $('.s-closebtn').on('click', function() {
        document.getElementById("sidebar-settings").style.left = "-30%";
        document.getElementById("main").style.marginLeft = "-29px";

        document.getElementById("s-openbtn").style.display = "block";
        document.getElementById("e-openbtn").style.display = "block";

        document.getElementById("s-openbtn").style.top = "110px";
      });

      // Sidebar edit
      $('.e-openbtn').on('click', function() {
        document.getElementById("sidebar-editing").style.left = "-34px";
        document.getElementById("main").style.marginLeft = "35%";

        this.style.display = "none";
        document.getElementById("s-openbtn").style.display = "block";
        document.getElementById("s-openbtn").style.top = "211px";

        // Close settings panal
        document.getElementById("sidebar-settings").style.left = "-30%";

      });
      $('.e-closebtn').on('click', function() {
        document.getElementById("sidebar-editing").style.left = "-40%";
        document.getElementById("main").style.marginLeft = "-29px";

        document.getElementById("s-openbtn").style.display = "block";
        document.getElementById("e-openbtn").style.display = "block";

        document.getElementById("s-openbtn").style.top = "110px";
      });
    },
  };

  function getInputFromContainer(container) {
    var inputName = $(container).data('input');

    if (inputName) {
      var input = $('input[name="' + inputName + '"]');

      if (input.length > 0) {
        return input;
      }
    }

    return null;
  }

  $.fn.updateJsonResponse = function (inputName, response) {
    // Document viwer.
    $('#document-view-content').html(response.view);

    // Json Response
    var editorDiv = $('div.jsoneditor--wrapper[data-input="ws_response"]:first');
    if (editorDiv.length > 0) {
      editorDiv[0].editor.set(response.result);
    }
  }

})(jQuery, Drupal);
